import { Home } from "@mui/icons-material";
import { Grid, Button, Box, Typography } from "@mui/material";
import React from "react";
import { useState } from "react";
/**
 *
 * @param {PropsType} props Component props
 * @returns {ReactElement} NerdAppsMenu
 */
export default function NerdAppsMenu(props) {
    const { apps, homePath } = props;
    return (React.createElement(Grid, { container: true, padding: "10px" },
        apps.map((app, i) => {
            var _a;
            return (React.createElement(Grid, { key: (_a = app.name) === null || _a === void 0 ? void 0 : _a.concat(i.toString()), item: true, xs: 4, sm: 3 },
                React.createElement(AppIcon, { app: app })));
        }),
        React.createElement(Grid, { item: true, xs: 12, mt: 2, textAlign: "center" },
            React.createElement(Button, { href: homePath, variant: "outlined", startIcon: React.createElement(Home, null) }, "Home"))));
}
/**
 *
 * @param {object} props Component props
 * @param {App} props.app App to render
 * @returns {ReactElement} AppIcon
 */
function AppIcon(props) {
    const { app } = props;
    const [hover, setHover] = useState(false);
    const transition = "ease-in";
    return (React.createElement(Box, { sx: {
            display: "flex",
            flexDirection: "column",
            alignContent: "center",
            alignItems: "center",
            animationDelay: `-${Math.random()}s`,
            animationDuration: `.${Math.floor(Math.random() * 11) + 20}s`,
        }, onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false) },
        app.url ? (React.createElement("a", { href: `https://${app.url}`, style: {
                textDecoration: "none",
            } }, app.icon ? (React.createElement("img", { src: app.icon, alt: "app_icon", width: 40, height: 40, style: {
                borderRadius: "20%",
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } })) : (React.createElement(Box, { sx: {
                backgroundColor: app.color,
                marginBottom: "5px",
                width: "40px",
                height: "40px",
                textAlign: "center",
                border: `solid ${40 * 0.05}px ${app.color}`,
                background: "#424242",
                color: app.color,
                fontFamily: "Futura",
                fontSize: 40 * 0.5,
                borderTopRightRadius: 40 * 0.5,
                borderBottomLeftRadius: 40 * 0.5,
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } },
            React.createElement(Grid, { container: true, justifyContent: "center", alignItems: "center", style: { height: 35 } }, app.name && React.createElement(Grid, { item: true }, `${app.name[0]}${app.name[1]}`)))))) : null,
        React.createElement(Typography, { fontWeight: "300", fontSize: "14px", textAlign: "center" }, app.name)));
}
