var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import CircularProgress from "@mui/material/CircularProgress";
import ClickAwayListener from "@mui/material/ClickAwayListener";
import Grid from "@mui/material/Grid";
import Paper from "@mui/material/Paper";
import React from "react";
import PersonSearchIcon from "@mui/icons-material/PersonSearch";
import { NerdHeading } from "../NerdHeading";
import MapTwoToneIcon from "@mui/icons-material/MapTwoTone";
import { Divider, Stack, Typography } from "@mui/material";
import "./NerdAutocomplete.scss";
import { uid } from "../utility/utils";
import { AutocompleteOnLoadHeading, AutocompleteType, } from "../NerdInput/NerdInputEnums";
/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */
export function PaperComponentOnLoad(paperProps) {
    const { className, inputValue, loading, autocompleteType } = paperProps, other = __rest(paperProps, ["className", "inputValue", "loading", "autocompleteType"]);
    return (React.createElement(Paper, Object.assign({}, other, { className: className ? "autocompleteSmall" : "" }),
        React.createElement(ClickAwayListener, { onClickAway: () => console.log("onClick") },
            React.createElement(React.Fragment, null, inputValue && loading ? (React.createElement(WrapperCustomerOnload, null,
                React.createElement(CircularProgress, { color: "primary", size: 40 }),
                React.createElement(NerdHeading, { text: "loading", variant: "h6" }))) : (contentOnLoad(autocompleteType, inputValue, loading))))));
}
const CustomerOnload = () => {
    return (React.createElement(WrapperCustomerOnload, null,
        React.createElement(PersonSearchIcon, { fontSize: "large" }),
        React.createElement(NerdHeading, { text: AutocompleteOnLoadHeading.CUSTOMER, variant: "h6" })));
};
const AdrressOnload = () => {
    return (React.createElement(React.Fragment, null,
        React.createElement(WrapperCustomerOnload, null,
            React.createElement(MapTwoToneIcon, { fontSize: "large" }),
            React.createElement(NerdHeading, { text: AutocompleteOnLoadHeading.ADDRESS, variant: "h6" })),
        React.createElement(Divider, null),
        React.createElement(Grid, { container: true, alignItems: "center", justifyContent: "center" },
            React.createElement(Grid, { item: true, py: 1 },
                React.createElement(Typography, { display: "block", variant: "caption", color: "textSecondary" },
                    "Powered by ",
                    React.createElement("b", null, "Google"),
                    " and ",
                    React.createElement("b", null, "Archer"))))));
};
const WrapperCustomerOnload = (props) => {
    return (React.createElement(Stack, { direction: "column", justifyContent: "center", alignItems: "center", spacing: 2, py: 7 }, props.children));
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */
function contentOnLoad(...args) {
    return args.map((arg, i) => {
        if (i === 0 && typeof arg === "string" && arg !== "") {
            switch (arg) {
                case AutocompleteType.CUSTOMER:
                    return React.createElement(CustomerOnload, { key: uid() });
                case AutocompleteType.ADDRESS:
                    return React.createElement(AdrressOnload, { key: uid() });
            }
        }
        return React.createElement(React.Fragment, { key: uid() });
    });
}
