import React, { useRef } from "react";
import Popover from "@mui/material/Popover";
import { NerdHeading } from "../NerdHeading";
import { styled } from "@mui/system";
import Box from "@mui/material/Box";
export const NerdHelp = ({ explanation, classes, children, anchorOrigin = {
    vertical: "top",
    horizontal: "left",
}, transformOrigin = {
    vertical: "bottom",
    horizontal: "left",
}, variant = "body1", }) => {
    const [anchorEl, setAnchorEl] = React.useState(null);
    const htmlRef = useRef(null);
    const open = Boolean(anchorEl);
    const onMouseEnter = () => {
        setAnchorEl(htmlRef.current);
    };
    const onMouseLeave = () => {
        setAnchorEl(null);
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(Box, { ref: htmlRef, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, children),
        React.createElement(StyledPopover, { sx: {
                pointerEvents: "none",
            }, open: open, anchorEl: anchorEl, anchorOrigin: anchorOrigin, transformOrigin: transformOrigin, classes: Object.assign({}, classes) },
            React.createElement(NerdHeading, { variant: variant, text: explanation, sx: { p: 1 } }))));
};
const StyledPopover = styled(Popover, {
    name: "StyledPopover",
    slot: "Wrapper",
})(() => ({
    width: "100%",
}));
