import React from "react";
import { MobileDatePicker } from "@mui/x-date-pickers/MobileDatePicker";
import { LocalizationProvider } from "@mui/x-date-pickers/LocalizationProvider";
import { AdapterMoment } from "@mui/x-date-pickers/AdapterMoment";
import TextField from "@mui/material/TextField";
import { InputAux } from "../NerdInputEnums";
import moment from "moment";
export const NerdDate = ({ label = "", placeholder = "", helperText = " ", required = false, variant = "standard", onChange, value, }) => {
    return (React.createElement(LocalizationProvider, { dateAdapter: AdapterMoment },
        React.createElement(MobileDatePicker, { label: label, value: value, onChange: onChange, minDate: moment(), renderInput: (params) => (React.createElement(TextField, Object.assign({}, params, { variant: variant, placeholder: placeholder, InputLabelProps: {
                    shrink: true,
                }, helperText: required ? InputAux.REQUIRED : helperText, required: required, fullWidth: true }))) })));
};
