var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState } from "react";
import Grid from "@mui/material/Grid";
import { ConditionalWrapper } from "../utility/ConditionalWrapper";
import IconButton from "@mui/material/IconButton";
import CloseIcon from "@mui/icons-material/Close";
import { NerdDate } from "./NerdDate/NerdDate";
import { NerdText } from "./NerdText/NerdText";
import { NerdPassword } from "./NerdPassword/NerdPassword";
export const NerdInput = (_a) => {
    var { type = "text" } = _a, props = __rest(_a, ["type"]);
    const [close, setClose] = useState(false);
    const { icon, spacing = 1, disabled, fullWidth, alignItems = "center", inputSize = 6, onChange, } = props;
    const sizeWithIcons = fullWidth ? 11 : inputSize;
    const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (React.createElement(ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (React.createElement(Grid, { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        React.createElement(React.Fragment, null,
            icon && React.createElement(Grid, { item: true }, icon),
            React.createElement(Grid, { item: true, sm: customInputSize, xs: icon ? 9 : 12 }, renderNerdInputByType({ type, props, close, setClose, onChange })),
            icon && (React.createElement(Grid, { item: true },
                React.createElement(IconButton, { disabled: disabled, size: "small", onClick: () => setClose(true) },
                    React.createElement(CloseIcon, null)))))));
};
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */
function renderNerdInputByType(auxProps) {
    const { type, props } = auxProps;
    switch (type) {
        case "date":
            return React.createElement(NerdDate, Object.assign({}, props));
        case "text":
            return React.createElement(NerdText, Object.assign({}, props));
        case "password":
            return React.createElement(NerdPassword, Object.assign({}, props));
        default:
            return React.createElement(NerdText, Object.assign({}, props));
    }
}
