// Generated with util/create-component.js
import React from "react";
import { NonIntrusive } from "./components/NonIntrusive";
import { Intrusive } from "./components/Intrusive";
const NerdNotifier = (props) => {
    const { notification, children, onClose } = props;
    const { variant = "non-intrusive", uuid } = notification;
    const [open, setOpen] = React.useState(false);
    React.useEffect(() => {
        if (uuid) {
            setOpen(true);
        }
    }, [uuid]);
    const handleClose = () => {
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
    };
    return (React.createElement(React.Fragment, null,
        children,
        variant === "non-intrusive" && open && (React.createElement(NonIntrusive, Object.assign({}, notification, { open: open, handleClose: handleClose }))),
        variant === "intrusive" && (React.createElement(Intrusive, Object.assign({}, notification, { open: open, onHandleClose: handleClose })))));
};
export default NerdNotifier;
