import { FirstPage, KeyboardArrowLeft, KeyboardArrowRight, } from "@mui/icons-material";
import { Box, Tooltip, IconButton } from "@mui/material";
import React from "react";
const CustomArrow = ({ onPageChange, page, disabledNext, children, }) => {
    const disablePrev = page === 1;
    return (React.createElement(Box, null,
        React.createElement(Tooltip, { title: "First Page", placement: "bottom", enterDelay: 300 },
            React.createElement("span", null,
                React.createElement(IconButton, { onClick: (e) => onPageChange(e, 1), disabled: disablePrev, "aria-label": "First Page" },
                    React.createElement(FirstPage, null)))),
        React.createElement(Tooltip, { title: "Prev Page", placement: "bottom", enterDelay: 300 },
            React.createElement("span", null,
                React.createElement(IconButton, { onClick: (e) => onPageChange(e, page - 1), disabled: disablePrev, "aria-label": "Previous Page" },
                    React.createElement(KeyboardArrowLeft, null)))),
        children,
        React.createElement(Tooltip, { title: "Next Page", placement: "bottom", enterDelay: 300 },
            React.createElement("span", null,
                React.createElement(IconButton, { onClick: (e) => {
                        onPageChange(e, page + 1);
                    }, "aria-label": "Next Page", disabled: disabledNext },
                    React.createElement(KeyboardArrowRight, null))))));
};
export default CustomArrow;
