import Grid from "@mui/material/Grid";
import Pagination from "@mui/material/Pagination";
import React from "react";
import CustomArrow from "./CustomArrow";
import "../NerdPagination.scss";
import { useMediaQuery, useTheme } from "@mui/material";
const PageActions = (props) => {
    const { page, onPageChange, selectPages, disabledNext } = props;
    const pagesStored = [
        ...Array.from(new Set(selectPages.sort((a, b) => a - b))),
    ];
    const theme = useTheme();
    const matches = useMediaQuery(theme.breakpoints.down("sm"));
    return (React.createElement(Grid, { container: true, alignItems: "center", className: "paginationContainer", sx: { marginLeft: "1rem" } },
        React.createElement(Grid, { item: true },
            React.createElement(CustomArrow, Object.assign({}, {
                onPageChange,
                page,
                disabledNext,
                pagesStored,
            }),
                React.createElement(Pagination, { count: pagesStored[pagesStored.length - 1], defaultPage: page, siblingCount: matches ? 0 : 1, size: matches ? "small" : "medium", hideNextButton: true, hidePrevButton: true, sx: {
                        display: "inline",
                        "&.MuiPagination-root *": {
                            display: "inline",
                        },
                    }, onChange: (event, page) => {
                        onPageChange(event, page);
                    } })))));
};
export default PageActions;
