"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const icons_material_1 = require("@mui/icons-material");
const material_1 = require("@mui/material");
const react_1 = __importDefault(require("react"));
const react_2 = require("react");
/**
 *
 * @param {PropsType} props Component props
 * @returns {ReactElement} NerdAppsMenu
 */
function NerdAppsMenu(props) {
    const { apps, homePath } = props;
    return (react_1.default.createElement(material_1.Grid, { container: true, padding: "10px" },
        apps.map((app, i) => {
            var _a;
            return (react_1.default.createElement(material_1.Grid, { key: (_a = app.name) === null || _a === void 0 ? void 0 : _a.concat(i.toString()), item: true, xs: 4, sm: 3 },
                react_1.default.createElement(AppIcon, { app: app })));
        }),
        react_1.default.createElement(material_1.Grid, { item: true, xs: 12, mt: 2, textAlign: "center" },
            react_1.default.createElement(material_1.Button, { href: homePath, variant: "outlined", startIcon: react_1.default.createElement(icons_material_1.Home, null) }, "Home"))));
}
exports.default = NerdAppsMenu;
/**
 *
 * @param {object} props Component props
 * @param {App} props.app App to render
 * @returns {ReactElement} AppIcon
 */
function AppIcon(props) {
    const { app } = props;
    const [hover, setHover] = (0, react_2.useState)(false);
    const transition = "ease-in";
    return (react_1.default.createElement(material_1.Box, { sx: {
            display: "flex",
            flexDirection: "column",
            alignContent: "center",
            alignItems: "center",
            animationDelay: `-${Math.random()}s`,
            animationDuration: `.${Math.floor(Math.random() * 11) + 20}s`,
        }, onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false) },
        app.url ? (react_1.default.createElement("a", { href: `https://${app.url}`, style: {
                textDecoration: "none",
            } }, app.icon ? (react_1.default.createElement("img", { src: app.icon, alt: "app_icon", width: 40, height: 40, style: {
                borderRadius: "20%",
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } })) : (react_1.default.createElement(material_1.Box, { sx: {
                backgroundColor: app.color,
                marginBottom: "5px",
                width: "40px",
                height: "40px",
                textAlign: "center",
                border: `solid ${40 * 0.05}px ${app.color}`,
                background: "#424242",
                color: app.color,
                fontFamily: "Futura",
                fontSize: 40 * 0.5,
                borderTopRightRadius: 40 * 0.5,
                borderBottomLeftRadius: 40 * 0.5,
                boxShadow: hover
                    ? "0 5px 18px 0 rgba(0,0,0,.3)"
                    : "0 5px 28px 0 rgba(0,0,0,.1)",
                transition: `box-shadow .2s ${transition}`,
            } },
            react_1.default.createElement(material_1.Grid, { container: true, justifyContent: "center", alignItems: "center", style: { height: 35 } }, app.name && react_1.default.createElement(material_1.Grid, { item: true }, `${app.name[0]}${app.name[1]}`)))))) : null,
        react_1.default.createElement(material_1.Typography, { fontWeight: "300", fontSize: "14px", textAlign: "center" }, app.name)));
}
