"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NerdAutoComplete = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
const Autocomplete_1 = __importDefault(require("@mui/material/Autocomplete"));
const TextField_1 = __importDefault(require("@mui/material/TextField"));
const react_1 = __importStar(require("react"));
const Paper_1 = __importDefault(require("@mui/material/Paper"));
const PaperComponentOnLoad_1 = require("./PaperComponentOnLoad");
const RenderTemplate_1 = require("./RenderTemplate");
// import "@emotion/core";
const ConditionalWrapper_1 = require("../utility/ConditionalWrapper");
const Grid_1 = __importDefault(require("@mui/material/Grid"));
const IconButton_1 = __importDefault(require("@mui/material/IconButton"));
const Edit_1 = __importDefault(require("@mui/icons-material/Edit"));
const Close_1 = __importDefault(require("@mui/icons-material/Close"));
const toolkit_1 = require("@reduxjs/toolkit");
const NerdInputEnums_1 = require("../NerdInput/NerdInputEnums");
require("./NerdAutocomplete.scss");
const NerdAutoComplete = ({ itemID, value, fullWidth, onChange, onInputChange, inputValue, label, placeholder, options = [], variant = "standard", required = false, helperText, loading, autocompleteType = NerdInputEnums_1.AutocompleteType.CUSTOMER, icon, spacing = 1, alignItems = "center", disabled = false, 
//inputSize = 6,
autoCompleteOptionLabel = "", className, isEditable = false, }) => {
    const [open, setOpen] = (0, react_1.useState)(false);
    // const sizeWithIcons = fullWidth ? 11 : inputSize;
    //const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (react_1.default.createElement(ConditionalWrapper_1.ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (react_1.default.createElement(Grid_1.default, { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        react_1.default.createElement(react_1.default.Fragment, null,
            icon && react_1.default.createElement(Grid_1.default, { item: true }, icon),
            react_1.default.createElement(Grid_1.default, { item: true, sm: true },
                react_1.default.createElement(Autocomplete_1.default, { id: itemID, open: open, value: value, fullWidth: fullWidth, onOpen: () => setOpen(true), onClose: () => setOpen(false), onChange: onChange, onInputChange: onInputChange, inputValue: inputValue, options: options, clearIcon: null, getOptionLabel: (option) => getOptionLabel(option, autoCompleteOptionLabel), onKeyDown: (event) => {
                        if (event.key === "Enter") {
                            // Prevent's default 'Enter' behavior.
                            event.preventDefault();
                            // handler code
                        }
                    }, renderInput: (params) => (react_1.default.createElement(TextField_1.default, Object.assign({}, params, { label: label, variant: variant, placeholder: placeholder, InputLabelProps: {
                            shrink: true,
                        }, InputProps: Object.assign(Object.assign({}, params.InputProps), { endAdornment: null }), helperText: renderHelperText(required, helperText), required: required, fullWidth: true }))), renderOption: (props, option) => {
                        return (react_1.default.createElement(RenderTemplate_1.RenderTemplate, Object.assign({}, props, { option: option, autocompleteType: autocompleteType, optionsArray: options })));
                    }, PaperComponent: (props) => {
                        if (!inputValue || loading) {
                            return (react_1.default.createElement(PaperComponentOnLoad_1.PaperComponentOnLoad, Object.assign({}, { props, inputValue, autocompleteType, loading }, { key: (0, toolkit_1.nanoid)(), className: className ? "autocompleteSmall" : "" })));
                        }
                        return (react_1.default.createElement(Paper_1.default, Object.assign({}, props, { key: (0, toolkit_1.nanoid)(), className: className ? "autocompleteSmall" : "" }), props.children));
                    } })),
            icon && (react_1.default.createElement(Grid_1.default, { item: true, flexDirection: "column", display: "flex" },
                isEditable && (react_1.default.createElement(IconButton_1.default, { disabled: disabled, size: "small", onClick: (event) => {
                        setOpen(false);
                        onChange(event, "");
                        onInputChange(event, "");
                    } },
                    react_1.default.createElement(Edit_1.default, { fontSize: "small" }))),
                react_1.default.createElement(IconButton_1.default, { disabled: disabled, size: "small", onClick: (event) => {
                        setOpen(false);
                        onChange(event, "");
                        onInputChange(event, "");
                    } },
                    react_1.default.createElement(Close_1.default, { fontSize: "small" })))))));
};
exports.NerdAutoComplete = NerdAutoComplete;
/**
 *
 * @param required
 * @param helperText
 */
function renderHelperText(required, helperText) {
    if (!helperText) {
        return "";
    }
    return required ? NerdInputEnums_1.InputAux.REQUIRED : helperText;
}
/**
 *
 * @param option
 * @param autoCompleteOptionLabel
 */
function getOptionLabel(option, autoCompleteOptionLabel) {
    if (typeof option === "string") {
        return option;
    }
    if (typeof option === "object" && Object.keys(option).length > 0) {
        return option[autoCompleteOptionLabel];
    }
    return "";
}
