"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaperComponentOnLoad = void 0;
const CircularProgress_1 = __importDefault(require("@mui/material/CircularProgress"));
const ClickAwayListener_1 = __importDefault(require("@mui/material/ClickAwayListener"));
const Grid_1 = __importDefault(require("@mui/material/Grid"));
const Paper_1 = __importDefault(require("@mui/material/Paper"));
const react_1 = __importDefault(require("react"));
const PersonSearch_1 = __importDefault(require("@mui/icons-material/PersonSearch"));
const NerdHeading_1 = require("../NerdHeading");
const MapTwoTone_1 = __importDefault(require("@mui/icons-material/MapTwoTone"));
const material_1 = require("@mui/material");
require("./NerdAutocomplete.scss");
const utils_1 = require("../utility/utils");
const NerdInputEnums_1 = require("../NerdInput/NerdInputEnums");
/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */
function PaperComponentOnLoad(paperProps) {
    const { className, inputValue, loading, autocompleteType } = paperProps, other = __rest(paperProps, ["className", "inputValue", "loading", "autocompleteType"]);
    return (react_1.default.createElement(Paper_1.default, Object.assign({}, other, { className: className ? "autocompleteSmall" : "" }),
        react_1.default.createElement(ClickAwayListener_1.default, { onClickAway: () => console.log("onClick") },
            react_1.default.createElement(react_1.default.Fragment, null, inputValue && loading ? (react_1.default.createElement(WrapperCustomerOnload, null,
                react_1.default.createElement(CircularProgress_1.default, { color: "primary", size: 40 }),
                react_1.default.createElement(NerdHeading_1.NerdHeading, { text: "loading", variant: "h6" }))) : (contentOnLoad(autocompleteType, inputValue, loading))))));
}
exports.PaperComponentOnLoad = PaperComponentOnLoad;
const CustomerOnload = () => {
    return (react_1.default.createElement(WrapperCustomerOnload, null,
        react_1.default.createElement(PersonSearch_1.default, { fontSize: "large" }),
        react_1.default.createElement(NerdHeading_1.NerdHeading, { text: NerdInputEnums_1.AutocompleteOnLoadHeading.CUSTOMER, variant: "h6" })));
};
const AdrressOnload = () => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(WrapperCustomerOnload, null,
            react_1.default.createElement(MapTwoTone_1.default, { fontSize: "large" }),
            react_1.default.createElement(NerdHeading_1.NerdHeading, { text: NerdInputEnums_1.AutocompleteOnLoadHeading.ADDRESS, variant: "h6" })),
        react_1.default.createElement(material_1.Divider, null),
        react_1.default.createElement(Grid_1.default, { container: true, alignItems: "center", justifyContent: "center" },
            react_1.default.createElement(Grid_1.default, { item: true, py: 1 },
                react_1.default.createElement(material_1.Typography, { display: "block", variant: "caption", color: "textSecondary" },
                    "Powered by ",
                    react_1.default.createElement("b", null, "Google"),
                    " and ",
                    react_1.default.createElement("b", null, "Archer"))))));
};
const WrapperCustomerOnload = (props) => {
    return (react_1.default.createElement(material_1.Stack, { direction: "column", justifyContent: "center", alignItems: "center", spacing: 2, py: 7 }, props.children));
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */
function contentOnLoad(...args) {
    return args.map((arg, i) => {
        if (i === 0 && typeof arg === "string" && arg !== "") {
            switch (arg) {
                case NerdInputEnums_1.AutocompleteType.CUSTOMER:
                    return react_1.default.createElement(CustomerOnload, { key: (0, utils_1.uid)() });
                case NerdInputEnums_1.AutocompleteType.ADDRESS:
                    return react_1.default.createElement(AdrressOnload, { key: (0, utils_1.uid)() });
            }
        }
        return react_1.default.createElement(react_1.default.Fragment, { key: (0, utils_1.uid)() });
    });
}
