"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderTemplate = void 0;
const Box_1 = __importDefault(require("@mui/system/Box"));
const react_1 = __importDefault(require("react"));
const CorporateFare_1 = __importDefault(require("@mui/icons-material/CorporateFare"));
const CardHeader_1 = __importDefault(require("@mui/material/CardHeader"));
const Avatar_1 = __importDefault(require("@mui/material/Avatar"));
const LocationOnTwoTone_1 = __importDefault(require("@mui/icons-material/LocationOnTwoTone"));
const colors_1 = require("@mui/material/colors");
const toolkit_1 = require("@reduxjs/toolkit");
const NerdInputEnums_1 = require("../NerdInput/NerdInputEnums");
const Grid_1 = __importDefault(require("@mui/material/Grid"));
const Typography_1 = __importDefault(require("@mui/material/Typography"));
const Divider_1 = __importDefault(require("@mui/material/Divider"));
const RenderTemplate = ({ props, option, autocompleteType, className = "", optionsArray = [], onClick, }) => {
    const ListFoot = () => {
        return optionsArray[optionsArray.length - 1] === option ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Divider_1.default, null),
            react_1.default.createElement(Grid_1.default, { container: true, alignItems: "center", justifyContent: "center" },
                react_1.default.createElement(Grid_1.default, { item: true, py: 1 },
                    react_1.default.createElement(Typography_1.default, { display: "block", variant: "caption", color: "textSecondary" },
                        "Powered by ",
                        react_1.default.createElement("b", null, "Google"),
                        " and ",
                        react_1.default.createElement("b", null, "Archer")))))) : null;
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Box_1.default, Object.assign({ key: (0, toolkit_1.nanoid)(), component: "li", sx: {
                backgroundColor: "transparent",
                svg: { flexShrink: 0, color: "white" },
                cursor: "pointer",
                "&:hover": {
                    backgroundColor: "rgba(0, 0, 0, 0.08)",
                },
            } }, props, { className: className, onClick: onClick }),
            react_1.default.createElement(CardHeader_1.default, { avatar: react_1.default.createElement(Avatar_1.default, { sx: {
                        bgcolor: setTemplateIconColorByType(autocompleteType, option),
                    }, "aria-label": autocompleteType }, setTemplateIconByType(autocompleteType)), title: setTemplateTitle(autocompleteType, option), titleTypographyProps: { fontWeight: "500", variant: "body1" }, subheader: setTemplateContentByType(autocompleteType, option), sx: {
                    py: 1,
                    px: 1,
                } })),
        react_1.default.createElement(ListFoot, null)));
};
exports.RenderTemplate = RenderTemplate;
/**
 *
 * @param type
 */
function setTemplateIconByType(type) {
    switch (type) {
        case NerdInputEnums_1.AutocompleteType.CUSTOMER:
            return react_1.default.createElement(CorporateFare_1.default, { fontSize: "medium" });
        case NerdInputEnums_1.AutocompleteType.ADDRESS:
            return react_1.default.createElement(LocationOnTwoTone_1.default, { fontSize: "medium" });
        default:
            return react_1.default.createElement(CorporateFare_1.default, { fontSize: "medium" });
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateIconColorByType(type, option) {
    switch (type) {
        case NerdInputEnums_1.AutocompleteType.CUSTOMER:
            return colors_1.blue[500];
        case NerdInputEnums_1.AutocompleteType.ADDRESS:
            if (option.name) {
                return colors_1.blue[500];
            }
            return colors_1.grey[500];
        default:
            return colors_1.blue[500];
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateContentByType(type, option) {
    const auxContentCredit = option.credit_on_hold ? " - ( Credit Hold )" : "";
    const auxContentInactivity = option.inactivity_hold
        ? " - ( Inactivity Hold )"
        : "";
    switch (type) {
        case NerdInputEnums_1.AutocompleteType.CUSTOMER:
            return `${option.line1} ${option.state} ${option.zip} ${auxContentCredit} ${auxContentInactivity}`;
        case NerdInputEnums_1.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.secondary_text}`;
            }
            return option.name;
        default:
            return "";
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateTitle(type, option) {
    switch (type) {
        case NerdInputEnums_1.AutocompleteType.CUSTOMER:
            return `${option.name}`;
        case NerdInputEnums_1.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.main_text}`;
            }
            return option.name;
        default:
            return "";
    }
}
