"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NerdDate = void 0;
const react_1 = __importDefault(require("react"));
const MobileDatePicker_1 = require("@mui/x-date-pickers/MobileDatePicker");
const LocalizationProvider_1 = require("@mui/x-date-pickers/LocalizationProvider");
const AdapterMoment_1 = require("@mui/x-date-pickers/AdapterMoment");
const TextField_1 = __importDefault(require("@mui/material/TextField"));
const NerdInputEnums_1 = require("../NerdInputEnums");
const moment_1 = __importDefault(require("moment"));
const NerdDate = ({ label = "", placeholder = "", helperText = " ", required = false, variant = "standard", onChange, value, }) => {
    return (react_1.default.createElement(LocalizationProvider_1.LocalizationProvider, { dateAdapter: AdapterMoment_1.AdapterMoment },
        react_1.default.createElement(MobileDatePicker_1.MobileDatePicker, { label: label, value: value, onChange: onChange, minDate: (0, moment_1.default)(), renderInput: (params) => (react_1.default.createElement(TextField_1.default, Object.assign({}, params, { variant: variant, placeholder: placeholder, InputLabelProps: {
                    shrink: true,
                }, helperText: required ? NerdInputEnums_1.InputAux.REQUIRED : helperText, required: required, fullWidth: true }))) })));
};
exports.NerdDate = NerdDate;
