"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NerdInput = void 0;
const react_1 = __importStar(require("react"));
const Grid_1 = __importDefault(require("@mui/material/Grid"));
const ConditionalWrapper_1 = require("../utility/ConditionalWrapper");
const IconButton_1 = __importDefault(require("@mui/material/IconButton"));
const Close_1 = __importDefault(require("@mui/icons-material/Close"));
const NerdDate_1 = require("./NerdDate/NerdDate");
const NerdText_1 = require("./NerdText/NerdText");
const NerdPassword_1 = require("./NerdPassword/NerdPassword");
const NerdInput = (_a) => {
    var { type = "text" } = _a, props = __rest(_a, ["type"]);
    const [close, setClose] = (0, react_1.useState)(false);
    const { icon, spacing = 1, disabled, fullWidth, alignItems = "center", inputSize = 6, onChange, } = props;
    const sizeWithIcons = fullWidth ? 11 : inputSize;
    const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (react_1.default.createElement(ConditionalWrapper_1.ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (react_1.default.createElement(Grid_1.default, { container: true, spacing: spacing, alignItems: alignItems }, childrenContent)) },
        react_1.default.createElement(react_1.default.Fragment, null,
            icon && react_1.default.createElement(Grid_1.default, { item: true }, icon),
            react_1.default.createElement(Grid_1.default, { item: true, sm: customInputSize, xs: icon ? 9 : 12 }, renderNerdInputByType({ type, props, close, setClose, onChange })),
            icon && (react_1.default.createElement(Grid_1.default, { item: true },
                react_1.default.createElement(IconButton_1.default, { disabled: disabled, size: "small", onClick: () => setClose(true) },
                    react_1.default.createElement(Close_1.default, null)))))));
};
exports.NerdInput = NerdInput;
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */
function renderNerdInputByType(auxProps) {
    const { type, props } = auxProps;
    switch (type) {
        case "date":
            return react_1.default.createElement(NerdDate_1.NerdDate, Object.assign({}, props));
        case "text":
            return react_1.default.createElement(NerdText_1.NerdText, Object.assign({}, props));
        case "password":
            return react_1.default.createElement(NerdPassword_1.NerdPassword, Object.assign({}, props));
        default:
            return react_1.default.createElement(NerdText_1.NerdText, Object.assign({}, props));
    }
}
