"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Generated with util/create-component.js
const react_1 = __importDefault(require("react"));
const NonIntrusive_1 = require("./components/NonIntrusive");
const Intrusive_1 = require("./components/Intrusive");
const NerdNotifier = (props) => {
    const { notification, children, onClose } = props;
    const { variant = "non-intrusive", uuid } = notification;
    const [open, setOpen] = react_1.default.useState(false);
    react_1.default.useEffect(() => {
        if (uuid) {
            setOpen(true);
        }
    }, [uuid]);
    const handleClose = () => {
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        children,
        variant === "non-intrusive" && open && (react_1.default.createElement(NonIntrusive_1.NonIntrusive, Object.assign({}, notification, { open: open, handleClose: handleClose }))),
        variant === "intrusive" && (react_1.default.createElement(Intrusive_1.Intrusive, Object.assign({}, notification, { open: open, onHandleClose: handleClose })))));
};
exports.default = NerdNotifier;
