"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const TablePagination_1 = __importDefault(require("@mui/material/TablePagination"));
const react_1 = __importDefault(require("react"));
const styles_1 = require("@mui/material/styles");
const useMediaQuery_1 = __importDefault(require("@mui/material/useMediaQuery"));
const PageActions_1 = __importDefault(require("./components/PageActions"));
const typings_1 = require("./typings");
require("./NerdPagination.scss");
const NerdPagination = ({ page, rowsPerPage, rowPageOptions, selectPages, disabledNext, handleChangePage, handleChangeRowsPerPage, }) => {
    const theme = (0, styles_1.useTheme)();
    const matches = (0, useMediaQuery_1.default)(theme.breakpoints.down("sm"));
    return (react_1.default.createElement(TablePagination_1.default, { component: "div", count: -1, page: page, onPageChange: handleChangePage, rowsPerPage: rowsPerPage, rowsPerPageOptions: rowPageOptions, onRowsPerPageChange: handleChangeRowsPerPage, ActionsComponent: (props) => (react_1.default.createElement(PageActions_1.default, Object.assign({ selectPages: selectPages, disabledNext: disabledNext }, props))), labelDisplayedRows: () => {
            return "";
        }, labelRowsPerPage: typings_1.nerdPaginationAuxContent.Rows, getItemAriaLabel: (type) => `Go to ${type} page`, backIconButtonProps: {
            "aria-label": "Previous Page",
        }, nextIconButtonProps: {
            "aria-label": "Next Page",
        }, className: `nerdUI--pagination ${matches ? "nerdUI--pagination-sm" : ""}` }));
};
exports.default = NerdPagination;
