"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Grid_1 = __importDefault(require("@mui/material/Grid"));
const Pagination_1 = __importDefault(require("@mui/material/Pagination"));
const react_1 = __importDefault(require("react"));
const CustomArrow_1 = __importDefault(require("./CustomArrow"));
require("../NerdPagination.scss");
const material_1 = require("@mui/material");
const PageActions = (props) => {
    const { page, onPageChange, selectPages, disabledNext } = props;
    const pagesStored = [
        ...Array.from(new Set(selectPages.sort((a, b) => a - b))),
    ];
    const theme = (0, material_1.useTheme)();
    const matches = (0, material_1.useMediaQuery)(theme.breakpoints.down("sm"));
    return (react_1.default.createElement(Grid_1.default, { container: true, alignItems: "center", className: "paginationContainer", sx: { marginLeft: "1rem" } },
        react_1.default.createElement(Grid_1.default, { item: true },
            react_1.default.createElement(CustomArrow_1.default, Object.assign({}, {
                onPageChange,
                page,
                disabledNext,
                pagesStored,
            }),
                react_1.default.createElement(Pagination_1.default, { count: pagesStored[pagesStored.length - 1], defaultPage: page, siblingCount: matches ? 0 : 1, size: matches ? "small" : "medium", hideNextButton: true, hidePrevButton: true, sx: {
                        display: "inline",
                        "&.MuiPagination-root *": {
                            display: "inline",
                        },
                    }, onChange: (event, page) => {
                        onPageChange(event, page);
                    } })))));
};
exports.default = PageActions;
