"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const material_1 = require("@mui/material");
const react_1 = __importDefault(require("react"));
/**
 * DataGrid boolean filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} CheckBox input for boolean type filter.
 */
function BoolOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = react_1.default.useRef(null);
    react_1.default.useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.checked }));
    };
    return (react_1.default.createElement(material_1.FormGroup, { sx: { justifyContent: "center" } },
        react_1.default.createElement(material_1.FormControlLabel, { control: react_1.default.createElement(material_1.Checkbox, { name: "custom-filter-operator", placeholder: "Value", checked: item.value || false, onChange: (e) => handleFilterChange(e) }), label: "Active" })));
}
exports.default = BoolOperatorInput;
