"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const material_1 = require("@mui/material");
const react_1 = __importDefault(require("react"));
const AdapterMoment_1 = require("@mui/x-date-pickers/AdapterMoment");
const LocalizationProvider_1 = require("@mui/x-date-pickers/LocalizationProvider");
const DatePicker_1 = require("@mui/x-date-pickers/DatePicker");
/**
 * DataGrid date filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} DatePicker input for date type filter.
 */
function DateOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = react_1.default.useRef(null);
    react_1.default.useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (value) => {
        applyValue(Object.assign(Object.assign({}, item), { value: value ? value.format("YYYY-MM-DD") : "" }));
    };
    return (react_1.default.createElement(LocalizationProvider_1.LocalizationProvider, { dateAdapter: AdapterMoment_1.AdapterMoment },
        react_1.default.createElement(DatePicker_1.DatePicker, { inputFormat: "YYYY/MM/DD", mask: "____/__/__", label: "Value", value: item.value || "", onChange: (value) => handleFilterChange(value), ref: ref, renderInput: (params) => (react_1.default.createElement(material_1.TextField, Object.assign({}, params, { placeholder: "Value", label: "Value", variant: "standard" }))) })));
}
exports.default = DateOperatorInput;
