"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorSwitch = exports.setCustomIconDefinition = exports.NerdIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const fontawesome_svg_core_1 = require("@fortawesome/fontawesome-svg-core");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
fontawesome_svg_core_1.library.add(free_solid_svg_icons_1.fas);
/**
 * This component is a wrapper for the FontAwesomeIcon component.
 * It is used to add icons to any library. More info here: https://fontawesome.com/v5/docs/web/use-with/react
 */
const NerdIcon = (props) => {
    const { icon, severity, iconColor, size = "3x", onMouseEnter, onMouseLeave, } = props;
    if (!icon) {
        return null;
    }
    return (react_1.default.createElement("span", { onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, typeof icon === "string" ? (setCustomIconString(Object.assign({ icon, severity, iconColor, size }))) : (react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon, size: size, color: iconColor !== null && iconColor !== void 0 ? iconColor : "#0288d1" }))));
};
exports.NerdIcon = NerdIcon;
/**
 *
 * @param root0
 * @param root0.icon
 * @param root0.iconColor
 * @param root0.severity
 * @param root0.size
 */
function setCustomIconString({ icon, iconColor, severity, size = "3x", }) {
    return (react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: setCustomIconDefinition(icon), color: iconColor && iconColor !== ""
            ? iconColor
            : colorSwitch(severity || "info"), size: size }));
}
//TODO: fontawesome-svg-core package needs to be updated. (v5.15.4 current version). The icons name are were changed.
/**
 *
 * @param icon
 */
function setCustomIconDefinition(icon) {
    const iconLookup = {
        prefix: "fas",
        iconName: icon,
    };
    const customIconDefinition = (0, fontawesome_svg_core_1.findIconDefinition)(iconLookup);
    return customIconDefinition;
}
exports.setCustomIconDefinition = setCustomIconDefinition;
/**
 *
 * @param color
 */
function colorSwitch(color) {
    switch (color) {
        case "error":
            return "#d32f2f";
        case "info":
            return "#0288d1";
        case "success":
            return "#2e7d32";
        case "warning":
            return "#ed6c02";
        default:
            return "#000";
    }
}
exports.colorSwitch = colorSwitch;
