"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorSwitch = exports.setCustomIconDefinition = exports.NerdFontAwesomeIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const fontawesome_svg_core_1 = require("@fortawesome/fontawesome-svg-core");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const Box_1 = __importDefault(require("@mui/material/Box"));
fontawesome_svg_core_1.library.add(free_solid_svg_icons_1.fas);
const NerdFontAwesomeIcon = react_1.default.forwardRef((props, ref) => {
    const { icon, severity, iconColor } = props;
    if (!icon) {
        return null;
    }
    return (react_1.default.createElement(Box_1.default, { mt: 2, mx: "auto", ref: ref }, typeof icon === "string" ? (setCustomIconString({ icon, severity, iconColor })) : (react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon, size: "3x", color: iconColor !== null && iconColor !== void 0 ? iconColor : "#0288d1" }))));
});
exports.NerdFontAwesomeIcon = NerdFontAwesomeIcon;
NerdFontAwesomeIcon.displayName = "NerdFontAwesomeIcon";
/**
 * @param {object} root0 props
 * @param {string} root0.icon Icon
 * @param {string} root0.iconColor Icon color
 * @param {string} root0.severity Severity
 * @returns {JSX.Element} Custom Icon String
 */
function setCustomIconString({ icon, iconColor, severity, }) {
    return (react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: setCustomIconDefinition(icon), color: iconColor && iconColor !== ""
            ? iconColor
            : (0, exports.colorSwitch)(severity || "info"), size: "3x" }));
}
/**
 * @param {IconName} icon Icon
 * @returns {IconDefinition} Custom Icon definition
 */
function setCustomIconDefinition(icon) {
    const iconLookup = {
        prefix: "fas",
        iconName: icon,
    };
    const customIconDefinition = (0, fontawesome_svg_core_1.findIconDefinition)(iconLookup);
    return customIconDefinition;
}
exports.setCustomIconDefinition = setCustomIconDefinition;
const colorSwitch = (color) => ({
    error: "#d32f2f",
    info: "#0288d1",
    success: "#2e7d32",
    warning: "#ed6c02",
}[color]);
exports.colorSwitch = colorSwitch;
