import { Checkbox, FormControlLabel, FormGroup } from "@mui/material";
import React from "react";
/**
 * DataGrid boolean filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} CheckBox input for boolean type filter.
 */
export default function BoolOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React.useRef(null);
    React.useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.checked }));
    };
    return (React.createElement(FormGroup, { sx: { justifyContent: "center" } },
        React.createElement(FormControlLabel, { control: React.createElement(Checkbox, { name: "custom-filter-operator", placeholder: "Value", checked: item.value || false, onChange: (e) => handleFilterChange(e) }), label: "Active" })));
}
