import { TextField } from "@mui/material";
import React from "react";
import { AdapterMoment } from "@mui/x-date-pickers/AdapterMoment";
import { LocalizationProvider } from "@mui/x-date-pickers/LocalizationProvider";
import { DatePicker } from "@mui/x-date-pickers/DatePicker";
/**
 * DataGrid date filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} DatePicker input for date type filter.
 */
export default function DateOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React.useRef(null);
    React.useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (value) => {
        applyValue(Object.assign(Object.assign({}, item), { value: value ? value.format("YYYY-MM-DD") : "" }));
    };
    return (React.createElement(LocalizationProvider, { dateAdapter: AdapterMoment },
        React.createElement(DatePicker, { inputFormat: "YYYY/MM/DD", mask: "____/__/__", label: "Value", value: item.value || "", onChange: (value) => handleFilterChange(value), ref: ref, renderInput: (params) => (React.createElement(TextField, Object.assign({}, params, { placeholder: "Value", label: "Value", variant: "standard" }))) })));
}
