import { TextField } from "@mui/material";
import React from "react";
/**
 * DataGrid string filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} TextField input for boolean type filter.
 */
export default function StringOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React.useRef(null);
    React.useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.value }));
    };
    return (React.createElement(TextField, { name: "custom-filter-operator", placeholder: "Value", label: "Value", variant: "standard", InputLabelProps: {
            shrink: true,
        }, value: item.value || "", onChange: (e) => handleFilterChange(e), ref: ref }));
}
